% make dummy PC data to test the linear fit part of
% optimal_THC_IC_by_linear_fit_2GFDL_CM2.m:

close all; clear all;

% # time steps:
N=1500;
% # EOFs:
I=4;

% specify linear operator:
rand('state',0);
%a=(rand(I,I)/0.2-eye(I)/5)/10;
%a=(-diag(abs(rand(I,1)))-eye(I))/50;
% two superimposed oscillators
a=[0 -0.05 0 0; 0.05 0 0 0; 0 0 0 0.03; 0 0 -0.03 0];
% a simple two component oscillation.  this helped find the bug I had...
% a=[0 -0.05; 0.05 0];
% make sure eigenvalues of propagator are stable:
[V,D]=eig(a);
for ii=1:I; 
  if real(D(ii,ii))>0; D(ii,ii)=-D(ii,ii); end
end; 
% reconstruct propagator with modified eigenvectors:
b=V*D*V^(-1);eig_b=eig(b);

% exponentiate to find propagator:
B=expm(b); 
format short; B=real(B);

% possibly show eigenvalues of propagator:
eig_B=eig(B)

% create principal componenet time series:
PC=zeros(N,I);
rand('state',1);
PC(1,:)=rand(1,I);
for n=2:N
  PC(n,:)=(B*PC(n-1,:)'+0*(rand(I,1)-0.5))';
end
PC=real(PC);

% plot principal componenets:
for ii=1:min(I,5)
  subplot(min(I,5),1,ii)
  plot([1:N],PC(:,ii));
end

% save time series to be read and used by
% optimal_THC_IC_by_linear_fit_2GFDL_CM2.m for testing of linear fit
% algorithm there:
save('Output/PCs.mat','PC');
